QCPSelectionDecoratorBracket Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Protected Functions
QCPSelectionDecoratorBracket Class Reference

A selection decorator which draws brackets around each selected data segment. More...

Inheritance diagram for QCPSelectionDecoratorBracket:

## Public Types
enum | BracketStyle

## Public Functions
| QCPSelectionDecoratorBracket ()
QPen | bracketPen () const
QBrush | bracketBrush () const
int | bracketWidth () const
int | bracketHeight () const
BracketStyle | bracketStyle () const
bool | tangentToData () const
int | tangentAverage () const
void | setBracketPen (const QPen &pen)
void | setBracketBrush (const QBrush &brush)
void | setBracketWidth (int width)
void | setBracketHeight (int height)
void | setBracketStyle (BracketStyle style)
void | setTangentToData (bool enabled)
void | setTangentAverage (int pointCount)
virtual void | drawBracket (QCPPainter *painter, int direction) const
virtual void | drawDecoration (QCPPainter *painter, QCPDataSelection selection)
Public Functions inherited from QCPSelectionDecorator
| QCPSelectionDecorator ()
QPen | pen () const
QBrush | brush () const
QCPScatterStyle | scatterStyle () const
QCPScatterStyle::ScatterProperties | usedScatterProperties () const
void | setPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setScatterStyle (const QCPScatterStyle &scatterStyle, QCPScatterStyle::ScatterProperties usedProperties=QCPScatterStyle::spPen)
void | setUsedScatterProperties (const QCPScatterStyle::ScatterProperties &properties)
void | applyPen (QCPPainter *painter) const
void | applyBrush (QCPPainter *painter) const
QCPScatterStyle | getFinalScatterStyle (const QCPScatterStyle &unselectedStyle) const
virtual void | copyFrom (const QCPSelectionDecorator *other)

## Protected Functions
double | getTangentAngle (const QCPPlottableInterface1D *interface1d, int dataIndex, int direction) const
QPointF | getPixelCoordinates (const QCPPlottableInterface1D *interface1d, int dataIndex) const
Protected Functions inherited from QCPSelectionDecorator
virtual bool | registerWithPlottable (QCPAbstractPlottable *plottable)

## Detailed Description

A selection decorator which draws brackets around each selected data segment.

Additionally to the regular highlighting of selected segments via color, fill and scatter style, this QCPSelectionDecorator subclass draws markers at the begin and end of each selected data segment of the plottable.

The shape of the markers can be controlled with setBracketStyle, setBracketWidth and setBracketHeight. The color/fill can be controlled with setBracketPen and setBracketBrush.

To introduce custom bracket styles, it is only necessary to sublcass QCPSelectionDecoratorBracket and reimplement drawBracket. The rest will be managed by the base class.

## Member Enumeration Documentation

## ◆ BracketStyle

enum QCPSelectionDecoratorBracket::BracketStyle

Defines which shape is drawn at the boundaries of selected data ranges.

Some of the bracket styles further allow specifying a height and/or width, see setBracketHeight and setBracketWidth.

Enumerator
bsSquareBracket | A square bracket is drawn.
bsHalfEllipse | A half ellipse is drawn. The size of the ellipse is given by the bracket width/height properties.
bsEllipse | An ellipse is drawn. The size of the ellipse is given by the bracket width/height properties.
bsPlus | A plus is drawn.
bsUserStyle | Start custom bracket styles at this index when subclassing and reimplementing drawBracket.

## Constructor & Destructor Documentation

## ◆ QCPSelectionDecoratorBracket()

QCPSelectionDecoratorBracket::QCPSelectionDecoratorBracket | ( |  | ) |

Creates a new QCPSelectionDecoratorBracket instance with default values.

## Member Function Documentation

## ◆ setBracketPen()

void QCPSelectionDecoratorBracket::setBracketPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the brackets at the beginning and end of each selected data segment.

## ◆ setBracketBrush()

void QCPSelectionDecoratorBracket::setBracketBrush | ( | const QBrush & | brush | ) |

Sets the brush that will be used to draw the brackets at the beginning and end of each selected data segment.

## ◆ setBracketWidth()

void QCPSelectionDecoratorBracket::setBracketWidth | ( | int | width | ) |

Sets the width of the drawn bracket. The width dimension is always parallel to the key axis of the data, or the tangent direction of the current data slope, if setTangentToData is enabled.

## ◆ setBracketHeight()

void QCPSelectionDecoratorBracket::setBracketHeight | ( | int | height | ) |

Sets the height of the drawn bracket. The height dimension is always perpendicular to the key axis of the data, or the tangent direction of the current data slope, if setTangentToData is enabled.

## ◆ setBracketStyle()

void QCPSelectionDecoratorBracket::setBracketStyle | ( | QCPSelectionDecoratorBracket::BracketStyle | style | ) |

Sets the shape that the bracket/marker will have.

See also
  setBracketWidth, setBracketHeight

## ◆ setTangentToData()

void QCPSelectionDecoratorBracket::setTangentToData | ( | bool | enabled | ) |

Sets whether the brackets will be rotated such that they align with the slope of the data at the position that they appear in.

For noisy data, it might be more visually appealing to average the slope over multiple data points. This can be configured via setTangentAverage.

## ◆ setTangentAverage()

void QCPSelectionDecoratorBracket::setTangentAverage | ( | int | pointCount | ) |

Controls over how many data points the slope shall be averaged, when brackets shall be aligned with the data (if setTangentToData is true).

From the position of the bracket, pointCount points towards the selected data range will be taken into account. The smallest value of pointCount is 1, which is effectively equivalent to disabling setTangentToData.

## ◆ drawBracket()

void QCPSelectionDecoratorBracket::drawBracket | ( | QCPPainter * | painter,
|  | int | direction ) const
| virtual

Draws the bracket shape with painter. The parameter direction is either -1 or 1 and indicates whether the bracket shall point to the left or the right (i.e. is a closing or opening bracket, respectively).

The passed painter already contains all transformations that are necessary to position and rotate the bracket appropriately. Painting operations can be performed as if drawing upright brackets on flat data with horizontal key axis, with (0, 0) being the center of the bracket.

If you wish to sublcass QCPSelectionDecoratorBracket in order to provide custom bracket shapes (see QCPSelectionDecoratorBracket::bsUserStyle), this is the method you should reimplement.

## ◆ drawDecoration()

void QCPSelectionDecoratorBracket::drawDecoration | ( | QCPPainter * | painter,
|  | QCPDataSelection | selection )
| virtual

Draws the bracket decoration on the data points at the begin and end of each selected data segment given in seletion.

It uses the method drawBracket to actually draw the shapes.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPSelectionDecorator.

## ◆ getTangentAngle()

double QCPSelectionDecoratorBracket::getTangentAngle | ( | const QCPPlottableInterface1D * | interface1d,
|  | int | dataIndex,
|  | int | direction ) const
| protected

If setTangentToData is enabled, brackets need to be rotated according to the data slope. This method returns the angle in radians by which a bracket at the given dataIndex must be rotated.

The parameter direction must be set to either -1 or 1, representing whether it is an opening or closing bracket. Since for slope calculation multiple data points are required, this defines the direction in which the algorithm walks, starting at dataIndex, to average those data points. (see setTangentToData and setTangentAverage)

interface1d is the interface to the plottable's data which is used to query data coordinates.

## ◆ getPixelCoordinates()

QPointF QCPSelectionDecoratorBracket::getPixelCoordinates | ( | const QCPPlottableInterface1D * | interface1d,
|  | int | dataIndex ) const
| protected

Returns the pixel coordinates of the data point at dataIndex, using interface1d to access the data points.

The documentation for this class was generated from the following files:

- src/selectiondecorator-bracket.h
- src/selectiondecorator-bracket.cpp